diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 4c2f46948..be081a4dd 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -301,7 +301,7 @@ public class RenderGlobal
         double cameraY = camera.getY(partialTick);
         double cameraZ = camera.getZ(partialTick);
         double cameraYaw = camera.getYRot(partialTick);
-        float temperature = (float)worldObj.getBlockTemperature((int)cameraX, (int)cameraZ);
+        double temperature = worldObj.getBlockTemperature((int)cameraX, (int)cameraZ);
         float mult = 0.0f;
         if (temperature <= 0.4f || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS)
         {
@@ -313,7 +313,7 @@ public class RenderGlobal
             mult += temperature;
         }
 
-        float altitude = (float)worldObj.getWorldType().getYPercentage((int)cameraY);
+        double altitude = worldObj.getWorldType().getYPercentage((int)cameraY);
         if ((temperature <= 0.6f || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && altitude >= 0.8f)
         {
             // altitude from 0.8f to 1.0f
@@ -326,13 +326,13 @@ public class RenderGlobal
         if (mult < 0.0f) mult = 0.0f;
         if (mult > 1.0f) mult = 1.0f;
 
-        if (Float.isNaN(targetAuroraBrightness))
+        if (Double.isNaN(targetAuroraBrightness))
         {
             auroraBrightness = mult;
         }
 
         targetAuroraBrightness = mult;
-        float totalDelta = targetAuroraBrightness - auroraBrightness;
+        double totalDelta = targetAuroraBrightness - auroraBrightness;
         auroraBrightnessDelta = totalDelta / 100;
         auroraBrightness += auroraBrightnessDelta * partialTick;
 
@@ -344,44 +344,44 @@ public class RenderGlobal
         GL11.glDisable(GL11.GL_FOG);
         GL11.glDisable(GL11.GL_ALPHA_TEST);
 
-        float scale = 1f;
-        float auroraY = (worldObj.getWorldType().getMinY() + worldObj.getWorldType().getYRange() + 64f) * 2f;
+        final double scale = 1f;
+        double auroraY = (worldObj.getWorldType().getMinY() + worldObj.getWorldType().getYRange() + 64f) * 2f;
 
         // Draw pieces
-        float rotationX = MathHelper.cos((float) ((cameraYaw * Math.PI) / 180F));
-        float rotationZ = MathHelper.sin((float) ((cameraYaw * Math.PI) / 180F));
+        double rotationX = Math.cos(((cameraYaw * Math.PI) / 180D));
+        double rotationZ = Math.sin(((cameraYaw * Math.PI) / 180D));
 
         renderEngine.bindTexture(renderEngine.getTexture("%blur%/environment/aurora.png"));
-        float time = worldObj.getWorldTime() + partialTick;
+        double time = worldObj.getWorldTime() + partialTick;
         AuroraProvider aurora = worldObj.auroraProvider;
 
-        float radius = 512;
+        double radius = 512;
         long worldTime = worldObj.getWorldTime();
 
         Tessellator.instance.startDrawingQuads();
-        for (float x = -radius; x < radius; x += 8f)
+        for (double x = -radius; x < radius; x += 8f)
         {
-            for (float z = -radius; z < radius; z += 8f)
+            for (double z = -radius; z < radius; z += 8f)
             {
-                float posX = (float) cameraX + x;
-                float posZ = (float) cameraZ + z;
+                double posX = cameraX + x;
+                double posZ = cameraZ + z;
 
-                float distanceSq = x * x + z + z;
-                float distanceSqPercentage = distanceSq / (radius * radius + radius * radius);
+                double distanceSq = x * x + z + z;
+                double distanceSqPercentage = distanceSq / (radius * radius + radius * radius);
                 distanceSqPercentage = 1f - distanceSqPercentage;
 
-                float sample = aurora.getAuroraPresence(posX, posZ, worldTime, celestialAngle) * auroraBrightness;
+                double sample = aurora.getAuroraPresence(posX, posZ, worldTime, celestialAngle) * auroraBrightness;
                 if (sample * 0.3f * distanceSqPercentage < 0.01f) continue;
 
                 renderAuroraBeam(
                     x * scale,
-                    (float) (auroraY * scale - cameraY * scale) + aurora.getAuroraHeightOffset(posX, posZ, time),
+                    (auroraY * scale - cameraY * scale) + aurora.getAuroraHeightOffset(posX, posZ, time),
                     z * scale,
                     rotationX, rotationZ,
                     aurora.getAuroraRedOffset(posX, posZ, time),
                     aurora.getAuroraGreenOffset(posX, posZ, time),
                     aurora.getAuroraBlueOffset(posX, posZ, time),
-                    scale, sample * 0.3f * distanceSqPercentage
+                    scale, (float) (sample * 0.3f * distanceSqPercentage)
                 );
             }
         }
@@ -395,7 +395,7 @@ public class RenderGlobal
         GL11.glDisable(GL11.GL_LIGHTING);
     }
 
-    private void renderAuroraBeam(float x, float y, float z, float xOffset, float zOffset, float redOffset, float greenOffset, float blueOffset, float scale, float transparency)
+    private void renderAuroraBeam(double x, double y, double z, double xOffset, double zOffset, float redOffset, float greenOffset, float blueOffset, double scale, float transparency)
     {
         float width = 16f;
         Tessellator tessellator = Tessellator.instance;
@@ -1142,109 +1142,81 @@ public class RenderGlobal
     	mc.renderer.endRenderClouds(partialTick);
     }
 
-    public boolean updateRenderers(ICamera camera)
-    {
-        byte numLayers = 2;
-        ChunkRendererComparator comparator = new ChunkRendererComparator(camera);
-        ChunkRenderer[] chunkRenderers = new ChunkRenderer[numLayers];
-        ArrayList<ChunkRenderer> arraylist = null;
-        int numChunkRenderersToUpdate = chunkRenderersToUpdate.size();
-        int i1 = 0;
-        for(int i = 0; i < numChunkRenderersToUpdate; i++)
-        {
-            ChunkRenderer chunkRenderer = chunkRenderersToUpdate.get(i);
-            if(chunkRenderer.distanceToCameraSquared(camera) > 256F)
-            {
-                int k2;
-                for(k2 = 0; k2 < numLayers && (chunkRenderers[k2] == null || comparator.compare(chunkRenderers[k2], chunkRenderer) <= 0); k2++) { }
-                if(--k2 <= 0)
-                {
+    public boolean updateRenderers(ICamera camera) {
+        final byte numLayers = 2;
+        final ChunkRendererComparator comparator = new ChunkRendererComparator(camera);
+        final ChunkRenderer[] chunkRenderers = new ChunkRenderer[numLayers];
+        List<ChunkRenderer> rendererList = null;
+        final int numChunkRenderersToUpdate = chunkRenderersToUpdate.size();
+        int renderListSize = 0;
+        for(int i = 0; i < numChunkRenderersToUpdate; i++) {
+            final ChunkRenderer chunkRenderer = chunkRenderersToUpdate.get(i);
+            if(chunkRenderer.distanceToCameraSquared(camera) > 256F) {
+                int layer = 0;
+                while (layer < numLayers && (chunkRenderers[layer] == null || comparator.compare(chunkRenderers[layer], chunkRenderer) <= 0)) {
+                    layer++;
+                }
+                if(--layer <= 0) {
                     continue;
                 }
-                for(int i3 = k2; --i3 != 0;)
-                {
+                for(int i3 = layer; --i3 != 0;) {
                     chunkRenderers[i3 - 1] = chunkRenderers[i3];
                 }
 
-                chunkRenderers[k2] = chunkRenderer;
+                chunkRenderers[layer] = chunkRenderer;
                 continue;
             }
-            if(arraylist == null)
-            {
-                arraylist = new ArrayList<>();
+            if(rendererList == null) {
+                rendererList = new ArrayList<>();
             }
-            i1++;
-            arraylist.add(chunkRenderer);
+            renderListSize++;
+            rendererList.add(chunkRenderer);
             chunkRenderersToUpdate.set(i, null);
         }
 
-        if(arraylist != null)
-        {
-            if(arraylist.size() > 1)
-            {
-                arraylist.sort(comparator);
+        if(rendererList != null) {
+            if(rendererList.size() > 1) {
+                rendererList.sort(comparator);
             }
-            for(int k1 = arraylist.size() - 1; k1 >= 0; k1--)
-            {
-                ChunkRenderer worldrenderer2 = arraylist.get(k1);
-                worldrenderer2.updateRenderer();
-                worldrenderer2.needsUpdate = false;
+            for (ChunkRenderer renderer : rendererList){
+                renderer.updateRenderer();
+                renderer.needsUpdate = false;
             }
-
         }
-        int l1 = 0;
-        for(int i2 = numLayers - 1; i2 >= 0; i2--)
-        {
-            ChunkRenderer worldrenderer3 = chunkRenderers[i2];
-            if(worldrenderer3 == null)
-            {
-                continue;
-            }
-            if(!worldrenderer3.isInFrustum && i2 != numLayers - 1)
-            {
-                chunkRenderers[i2] = null;
-                chunkRenderers[0] = null;
+        int renderersUpdated = 0;
+        for(int layer = numLayers - 1; layer >= 0; layer--) {
+            ChunkRenderer renderer = chunkRenderers[layer];
+            if(renderer == null) { continue; }
+            if(!renderer.isInFrustum && layer != numLayers - 1) {
+                chunkRenderers[layer] = null;
                 break;
             }
-            chunkRenderers[i2].updateRenderer();
-            chunkRenderers[i2].needsUpdate = false;
-            l1++;
+            renderer.updateRenderer();
+            renderer.needsUpdate = false;
+            renderersUpdated++;
         }
 
-        int j2 = 0;
-        int l2 = 0;
-        for(int j3 = chunkRenderersToUpdate.size(); j2 != j3; j2++)
-        {
-            ChunkRenderer worldrenderer4 = chunkRenderersToUpdate.get(j2);
-            if(worldrenderer4 == null)
-            {
-                continue;
-            }
-            boolean flag2 = false;
-            for(int k3 = 0; k3 < numLayers && !flag2; k3++)
-            {
-                if(worldrenderer4 == chunkRenderers[k3])
-                {
-                    flag2 = true;
+        int renderIndex = 0;
+        int setRenders = 0;
+        label1: for (int size = chunkRenderersToUpdate.size(); renderIndex != size; renderIndex++) {
+            final ChunkRenderer renderer = chunkRenderersToUpdate.get(renderIndex);
+            if(renderer == null) { continue; }
+            for(int layer = 0; layer < numLayers; layer++) {
+                if (renderer == chunkRenderers[layer]) {
+                    continue label1;
                 }
             }
 
-            if(flag2)
-            {
-                continue;
+            if(setRenders != renderIndex) {
+                chunkRenderersToUpdate.set(setRenders, renderer);
             }
-            if(l2 != j2)
-            {
-                chunkRenderersToUpdate.set(l2, worldrenderer4);
-            }
-            l2++;
+            setRenders++;
         }
 
-        while(--j2 >= l2) 
-        {
-            chunkRenderersToUpdate.remove(j2);
+        while(--renderIndex >= setRenders) {
+            chunkRenderersToUpdate.remove(renderIndex);
         }
-        return numChunkRenderersToUpdate == i1 + l1;
+        return numChunkRenderersToUpdate == (renderListSize + renderersUpdated);
     }
 
     public void drawBlockBreaking(ICamera camera, HitResult hitResult, float partialTick)
@@ -1466,32 +1438,32 @@ public class RenderGlobal
 		glEnable(GL_FOG);
 	}
 
-    public void drawOutlinedBoundingBox(AABB axisalignedbb)
+    public void drawOutlinedBoundingBox(AABB aabb)
     {
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawing(GL11.GL_LINE_STRIP);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
         tessellator.draw();
         tessellator.startDrawing(GL11.GL_LINE_STRIP);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
         tessellator.draw();
         tessellator.startDrawing(GL11.GL_LINES);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.minZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.maxY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.maxZ);
-        tessellator.addVertex(axisalignedbb.minX, axisalignedbb.maxY, axisalignedbb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.minZ);
+        tessellator.addVertex(aabb.maxX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.maxX, aabb.maxY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.minY, aabb.maxZ);
+        tessellator.addVertex(aabb.minX, aabb.maxY, aabb.maxZ);
         tessellator.draw();
     }
 
@@ -1753,8 +1725,8 @@ public class RenderGlobal
 
     public List<TileEntity> tileEntities;
     private World worldObj;
-    private RenderEngine renderEngine;
-    private List<ChunkRenderer> chunkRenderersToUpdate;
+    private final RenderEngine renderEngine;
+    private final List<ChunkRenderer> chunkRenderersToUpdate;
     private ChunkRenderer[] sortedChunkRenderers;
     private ChunkRenderer[] chunkRenderers;
     private int renderChunksWide;
@@ -1793,8 +1765,8 @@ public class RenderGlobal
     private int renderersBeingRendered;
     private int renderersSkippingRenderPass;
     private int worldRenderersCheckIndex;
-    private List<ChunkRenderer> glRenderLists;
-    private DisplayList allDisplayLists[] = {
+    private final List<ChunkRenderer> glRenderLists;
+    private final DisplayList[] allDisplayLists = {
         new DisplayList(), new DisplayList(), new DisplayList(), new DisplayList()
     };
     int dummyInt0;
@@ -1805,7 +1777,7 @@ public class RenderGlobal
     public float damagePartialTime;
     int frustumCheckOffset;
 
-    private float auroraBrightness = 0.0f;
-    private float targetAuroraBrightness = Float.NaN;
-    private float auroraBrightnessDelta = Float.NaN;
+    private double auroraBrightness = 0.0f;
+    private double targetAuroraBrightness = Double.NaN;
+    private double auroraBrightnessDelta = Double.NaN;
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 17d3fca7e..b853530bc 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public abstract class BlockModel<T extends Block>
 {
@@ -28,10 +29,10 @@ public abstract class BlockModel<T extends Block>
         renderBlocks.overrideBlockTexture = null;
         return result;
     }
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness){
-        renderBlockOnInventory(tessellator, metadata, brightness, 1f);
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, @Nullable Integer lightmapCoordinate){
+        renderBlockOnInventory(tessellator, metadata, brightness, 1f, lightmapCoordinate);
     }
-    public abstract void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha);
+    public abstract void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate);
     public abstract boolean shouldItemRender3d();
     public abstract float getItemRenderScale();
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
index 5b78751a1..5c36b7387 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
@@ -1,14 +1,13 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockBrazier;
-import net.minecraft.core.block.BlockFire;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelBrazier<T extends BlockBrazier>
@@ -28,15 +27,19 @@ public class BlockModelBrazier<T extends BlockBrazier>
         renderBlocks.enableAO = true;
         renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
         renderSide(tessellator, block, x, y, z, Side.NORTH, 0);
-        renderSide(tessellator, block, x, y, z + 1, Side.NORTH, 0);
         renderSide(tessellator, block, x, y, z, Side.SOUTH, 0);
-        renderSide(tessellator, block, x, y, z - 1, Side.SOUTH, 0);
         renderSide(tessellator, block, x, y, z, Side.EAST, 0);
-        renderSide(tessellator, block, x - 1, y, z, Side.EAST, 0);
         renderSide(tessellator, block, x, y, z, Side.WEST, 0);
-        renderSide(tessellator, block, x + 1, y, z, Side.WEST, 0);
         renderSide(tessellator, block, x, y, z, Side.BOTTOM, 0);
+
+        final double zFightOffset = 0.005;
+        block.setBlockBounds(-zFightOffset, -zFightOffset, -zFightOffset, 1 + zFightOffset, 1 + zFightOffset, 1 + zFightOffset);
+        renderSide(tessellator, block, x, y, z + 1, Side.NORTH, 0);
+        renderSide(tessellator, block, x, y, z - 1, Side.SOUTH, 0);
+        renderSide(tessellator, block, x - 1, y, z, Side.EAST, 0);
+        renderSide(tessellator, block, x + 1, y, z, Side.WEST, 0);
         renderSide(tessellator, block, x, y - 1, z, Side.TOP, 0);
+        block.setBlockBounds(0, 0, 0, 1, 1, 1);
         renderBlocks.enableAO = false;
 
         if (block.isBurning()) {
@@ -47,7 +50,7 @@ public class BlockModelBrazier<T extends BlockBrazier>
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         GL11.glColor4f(brightness, brightness, brightness, alpha);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java
index eb08896bf..d962fb936 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelCacaoLeaves<T extends Block> extends BlockModelLeaves<T>{
@@ -52,8 +53,8 @@ public class BlockModelCacaoLeaves<T extends Block> extends BlockModelLeaves<T>{
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha);
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         final IconCoordinate cacaoCoord = growthStages[3];
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
index bbe0fd74f..17b00a8bc 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelCactus<T extends Block> extends BlockModelStandard<T> {
@@ -33,7 +34,7 @@ public class BlockModelCactus<T extends Block> extends BlockModelStandard<T> {
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha){
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate){
         if(renderBlocks.useInventoryTint)
         {
             int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCherryLeavesBloom.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCherryLeavesBloom.java
index 672c2bac6..b58434ea2 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCherryLeavesBloom.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCherryLeavesBloom.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelCherryLeavesBloom<T extends Block> extends BlockModelLeaves<T> {
@@ -30,8 +31,8 @@ public class BlockModelCherryLeavesBloom<T extends Block> extends BlockModelLeav
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha);
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         IconCoordinate cherryCoord = grownCherryOverlay;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index ac52c4e53..7fe1d29b6 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandard<T> {
@@ -13,17 +14,21 @@ public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandar
         super(block);
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        if (LightmapHelper.isLightmapEnabled()){
+            brightness = 1f;
+        }
+        float r = 1f;
+        float g = 1f;
+        float b = 1f;
         // Used for the rendering for the block inside the jar
+        GL11.glColor4f(1f, 1f, 1f,1f);
         if(renderBlocks.useInventoryTint)
         {
             int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
-            float r = (float)(color >> 16 & 0xff) / 255F;
-            float g = (float)(color >> 8 & 0xff) / 255F;
-            float b = (float)(color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        } else {
-            GL11.glColor4f(brightness, brightness, brightness, alpha);
+             r = (float)(color >> 16 & 0xff) / 255F;
+             g = (float)(color >> 8 & 0xff) / 255F;
+             b = (float)(color & 0xff) / 255F;
         }
         final float yOffset = 0.0F;
 
@@ -41,7 +46,11 @@ public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandar
         final double maxV = texIndex.getIconVMax();
 
         tessellator.startDrawingQuads();
-        tessellator.setNormal(1.0F, 0.0F, 1.0F);
+        tessellator.setColorOpaque_F(r * brightness, g * brightness, b * brightness);
+        tessellator.setNormal(0.0F, 1.0F, 0.0F);
+        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
+            tessellator.setLightmapCoord(lightmapCoordinate);
+        }
 
         double xd = 0;
         double yd = 0;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 8598ae8a2..6e4db5802 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -294,7 +294,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelMotionSensor(Block.motionsensorActive).withTextures("minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_active_front", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side", "minecraft:block/motionsensor_side"));
 
         addDispatch(new BlockModelRepeater(Block.repeaterIdle).withTextures("minecraft:block/repeater_idle_top", "minecraft:block/polished_stone_top"));
-        addDispatch(new BlockModelRepeater(Block.repeaterActive).withTextures("minecraft:block/repeater_active_top", "minecraft:block/polished_stone_top"));
+        addDispatch(new BlockModelRepeater(Block.repeaterActive).withTextures("minecraft:block/repeater_active_top", "minecraft:block/polished_stone_top").withOverbrightTexture("minecraft:block/repeater_active_overlay"));
 
         addDispatch(new BlockModelPiston<>(Block.pistonBase, TextureRegistry.getTexture("minecraft:block/piston_face")).withTextures("minecraft:block/piston_face").withCustomItemBounds(0,0,0,1,1,1));
         addDispatch(new BlockModelPiston<>(Block.pistonBaseSticky,TextureRegistry.getTexture("minecraft:block/piston_face_sticky")).withTextures("minecraft:block/piston_face_sticky").withCustomItemBounds(0,0,0,1,1,1));
@@ -367,7 +367,7 @@ public class BlockModelDispatcher
 
         addDispatch(new BlockModelLayer<>(Block.layerSnow).withTextures("minecraft:block/block_snow"));
         addDispatch(new BlockModelLayer<>(Block.layerLeavesOak).withTextures("minecraft:block/leaves_oak_fancy"));
-        addDispatch(new BlockModelLayer<>(Block.layerSlate).withTextures("minecraft:block/slate_top"));
+        addDispatch(new BlockModelLayer<>(Block.layerSlate).withTextures("minecraft:block/slate_top", "minecraft:block/slate_side"));
 
         addDispatch(new BlockModelIce<>(Block.ice).withTextures("minecraft:block/ice"));
         addDispatch(new BlockModelStandard<>(Block.permaice).withTextures("minecraft:block/permaice"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
index 04b2aace3..826772431 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelEmpty extends BlockModelStandard<Block> {
     public BlockModelEmpty(Block block) {
@@ -14,7 +15,7 @@ public class BlockModelEmpty extends BlockModelStandard<Block> {
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
 
     }
 
